=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpDebClient
  class ContentPackagesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a package
    # Trigger an asynchronous task to create content,optionally create new repository version.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :repository A URI of a repository the new content unit should be associated with.
    # @option opts [String] :artifact Artifact file representing the physical content
    # @option opts [String] :relative_path Path where the artifact is located relative to distributions base_path
    # @option opts [File] :file An uploaded file that may be turned into the content unit.
    # @option opts [String] :upload An uncommitted upload that may be turned into the content unit.
    # @option opts [String] :distribution Name of the distribution.
    # @option opts [String] :component Name of the component.
    # @return [AsyncOperationResponse]
    def create(opts = {})
      data, _status_code, _headers = create_with_http_info(opts)
      data
    end

    # Create a package
    # Trigger an asynchronous task to create content,optionally create new repository version.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :repository A URI of a repository the new content unit should be associated with.
    # @option opts [String] :artifact Artifact file representing the physical content
    # @option opts [String] :relative_path Path where the artifact is located relative to distributions base_path
    # @option opts [File] :file An uploaded file that may be turned into the content unit.
    # @option opts [String] :upload An uncommitted upload that may be turned into the content unit.
    # @option opts [String] :distribution Name of the distribution.
    # @option opts [String] :component Name of the component.
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def create_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagesApi.create ...'
      end
      if @api_client.config.client_side_validation && !opts[:'relative_path'].nil? && opts[:'relative_path'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"relative_path"]" when calling ContentPackagesApi.create, the character length must be great than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'distribution'].nil? && opts[:'distribution'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"distribution"]" when calling ContentPackagesApi.create, the character length must be great than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'component'].nil? && opts[:'component'].to_s.length < 1
        fail ArgumentError, 'invalid value for "opts[:"component"]" when calling ContentPackagesApi.create, the character length must be great than or equal to 1.'
      end

      # resource path
      local_var_path = '/pulp/api/v3/content/deb/packages/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['multipart/form-data', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}
      form_params['repository'] = opts[:'repository'] if !opts[:'repository'].nil?
      form_params['artifact'] = opts[:'artifact'] if !opts[:'artifact'].nil?
      form_params['relative_path'] = opts[:'relative_path'] if !opts[:'relative_path'].nil?
      form_params['file'] = opts[:'file'] if !opts[:'file'].nil?
      form_params['upload'] = opts[:'upload'] if !opts[:'upload'].nil?
      form_params['distribution'] = opts[:'distribution'] if !opts[:'distribution'].nil?
      form_params['component'] = opts[:'component'] if !opts[:'component'].nil?

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagesApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List packages
    # A Package represents a '.deb' binary package.  Associated artifacts: Exactly one '.deb' package file.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :architecture Filter results where architecture matches value
    # @option opts [String] :auto_built_package Filter results where auto_built_package matches value
    # @option opts [Boolean] :build_essential Filter results where build_essential matches value  * &#x60;True&#x60; - yes * &#x60;False&#x60; - no
    # @option opts [String] :built_using Filter results where built_using matches value
    # @option opts [Boolean] :essential Filter results where essential matches value  * &#x60;True&#x60; - yes * &#x60;False&#x60; - no
    # @option opts [Integer] :installed_size Filter results where installed_size matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :maintainer Filter results where maintainer matches value
    # @option opts [String] :multi_arch Filter results where multi_arch matches value  * &#x60;no&#x60; - no * &#x60;same&#x60; - same * &#x60;foreign&#x60; - foreign * &#x60;allowed&#x60; - allowed
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;upstream_id&#x60; - Upstream id * &#x60;-upstream_id&#x60; - Upstream id (descending) * &#x60;timestamp_of_interest&#x60; - Timestamp of interest * &#x60;-timestamp_of_interest&#x60; - Timestamp of interest (descending) * &#x60;package&#x60; - Package * &#x60;-package&#x60; - Package (descending) * &#x60;source&#x60; - Source * &#x60;-source&#x60; - Source (descending) * &#x60;version&#x60; - Version * &#x60;-version&#x60; - Version (descending) * &#x60;architecture&#x60; - Architecture * &#x60;-architecture&#x60; - Architecture (descending) * &#x60;section&#x60; - Section * &#x60;-section&#x60; - Section (descending) * &#x60;priority&#x60; - Priority * &#x60;-priority&#x60; - Priority (descending) * &#x60;origin&#x60; - Origin * &#x60;-origin&#x60; - Origin (descending) * &#x60;tag&#x60; - Tag * &#x60;-tag&#x60; - Tag (descending) * &#x60;bugs&#x60; - Bugs * &#x60;-bugs&#x60; - Bugs (descending) * &#x60;essential&#x60; - Essential * &#x60;-essential&#x60; - Essential (descending) * &#x60;build_essential&#x60; - Build essential * &#x60;-build_essential&#x60; - Build essential (descending) * &#x60;installed_size&#x60; - Installed size * &#x60;-installed_size&#x60; - Installed size (descending) * &#x60;maintainer&#x60; - Maintainer * &#x60;-maintainer&#x60; - Maintainer (descending) * &#x60;original_maintainer&#x60; - Original maintainer * &#x60;-original_maintainer&#x60; - Original maintainer (descending) * &#x60;description&#x60; - Description * &#x60;-description&#x60; - Description (descending) * &#x60;description_md5&#x60; - Description md5 * &#x60;-description_md5&#x60; - Description md5 (descending) * &#x60;homepage&#x60; - Homepage * &#x60;-homepage&#x60; - Homepage (descending) * &#x60;built_using&#x60; - Built using * &#x60;-built_using&#x60; - Built using (descending) * &#x60;auto_built_package&#x60; - Auto built package * &#x60;-auto_built_package&#x60; - Auto built package (descending) * &#x60;multi_arch&#x60; - Multi arch * &#x60;-multi_arch&#x60; - Multi arch (descending) * &#x60;breaks&#x60; - Breaks * &#x60;-breaks&#x60; - Breaks (descending) * &#x60;conflicts&#x60; - Conflicts * &#x60;-conflicts&#x60; - Conflicts (descending) * &#x60;depends&#x60; - Depends * &#x60;-depends&#x60; - Depends (descending) * &#x60;recommends&#x60; - Recommends * &#x60;-recommends&#x60; - Recommends (descending) * &#x60;suggests&#x60; - Suggests * &#x60;-suggests&#x60; - Suggests (descending) * &#x60;enhances&#x60; - Enhances * &#x60;-enhances&#x60; - Enhances (descending) * &#x60;pre_depends&#x60; - Pre depends * &#x60;-pre_depends&#x60; - Pre depends (descending) * &#x60;provides&#x60; - Provides * &#x60;-provides&#x60; - Provides (descending) * &#x60;replaces&#x60; - Replaces * &#x60;-replaces&#x60; - Replaces (descending) * &#x60;relative_path&#x60; - Relative path * &#x60;-relative_path&#x60; - Relative path (descending) * &#x60;sha256&#x60; - Sha256 * &#x60;-sha256&#x60; - Sha256 (descending) * &#x60;custom_fields&#x60; - Custom fields * &#x60;-custom_fields&#x60; - Custom fields (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [String] :origin Filter results where origin matches value
    # @option opts [String] :original_maintainer Filter results where original_maintainer matches value
    # @option opts [Float] :orphaned_for Minutes Content has been orphaned for. -1 uses ORPHAN_PROTECTION_TIME.
    # @option opts [String] :package Filter results where package matches value
    # @option opts [String] :package__contains Filter results where package contains value
    # @option opts [String] :package__icontains Filter results where package contains value
    # @option opts [String] :package__iexact Filter results where package matches value
    # @option opts [Array<String>] :package__in Filter results where package is in a comma-separated list of values
    # @option opts [String] :package__iregex Filter results where package matches regex value
    # @option opts [String] :package__istartswith Filter results where package starts with value
    # @option opts [String] :package__regex Filter results where package matches regex value
    # @option opts [String] :package__startswith Filter results where package starts with value
    # @option opts [String] :priority Filter results where priority matches value
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q 
    # @option opts [String] :relative_path Filter results where relative_path matches value
    # @option opts [String] :release      Must be a comma-separated string: \&quot;release_href,repository_or_repository_version_href\&quot;     release_href: Filter results where Package in Release     repository_or_repository_version_href: The RepositoryVersion href to filter by, or Repository         href (assume latest version)     
    # @option opts [String] :release_component      Must be a comma-separated string: \&quot;release_component_href,repository_or_repository_version_href\&quot;     release_component_href: Filter results where Package in ReleaseComponent     repository_or_repository_version_href: The RepositoryVersion href to filter by, or Repository         href (assume latest version)     
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :section Filter results where section matches value
    # @option opts [String] :sha256 Filter results where sha256 matches value
    # @option opts [String] :source Filter results where source matches value
    # @option opts [String] :tag Filter results where tag matches value
    # @option opts [String] :version Filter results where version matches value
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginateddebPackageResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List packages
    # A Package represents a &#39;.deb&#39; binary package.  Associated artifacts: Exactly one &#39;.deb&#39; package file.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :architecture Filter results where architecture matches value
    # @option opts [String] :auto_built_package Filter results where auto_built_package matches value
    # @option opts [Boolean] :build_essential Filter results where build_essential matches value  * &#x60;True&#x60; - yes * &#x60;False&#x60; - no
    # @option opts [String] :built_using Filter results where built_using matches value
    # @option opts [Boolean] :essential Filter results where essential matches value  * &#x60;True&#x60; - yes * &#x60;False&#x60; - no
    # @option opts [Integer] :installed_size Filter results where installed_size matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :maintainer Filter results where maintainer matches value
    # @option opts [String] :multi_arch Filter results where multi_arch matches value  * &#x60;no&#x60; - no * &#x60;same&#x60; - same * &#x60;foreign&#x60; - foreign * &#x60;allowed&#x60; - allowed
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;upstream_id&#x60; - Upstream id * &#x60;-upstream_id&#x60; - Upstream id (descending) * &#x60;timestamp_of_interest&#x60; - Timestamp of interest * &#x60;-timestamp_of_interest&#x60; - Timestamp of interest (descending) * &#x60;package&#x60; - Package * &#x60;-package&#x60; - Package (descending) * &#x60;source&#x60; - Source * &#x60;-source&#x60; - Source (descending) * &#x60;version&#x60; - Version * &#x60;-version&#x60; - Version (descending) * &#x60;architecture&#x60; - Architecture * &#x60;-architecture&#x60; - Architecture (descending) * &#x60;section&#x60; - Section * &#x60;-section&#x60; - Section (descending) * &#x60;priority&#x60; - Priority * &#x60;-priority&#x60; - Priority (descending) * &#x60;origin&#x60; - Origin * &#x60;-origin&#x60; - Origin (descending) * &#x60;tag&#x60; - Tag * &#x60;-tag&#x60; - Tag (descending) * &#x60;bugs&#x60; - Bugs * &#x60;-bugs&#x60; - Bugs (descending) * &#x60;essential&#x60; - Essential * &#x60;-essential&#x60; - Essential (descending) * &#x60;build_essential&#x60; - Build essential * &#x60;-build_essential&#x60; - Build essential (descending) * &#x60;installed_size&#x60; - Installed size * &#x60;-installed_size&#x60; - Installed size (descending) * &#x60;maintainer&#x60; - Maintainer * &#x60;-maintainer&#x60; - Maintainer (descending) * &#x60;original_maintainer&#x60; - Original maintainer * &#x60;-original_maintainer&#x60; - Original maintainer (descending) * &#x60;description&#x60; - Description * &#x60;-description&#x60; - Description (descending) * &#x60;description_md5&#x60; - Description md5 * &#x60;-description_md5&#x60; - Description md5 (descending) * &#x60;homepage&#x60; - Homepage * &#x60;-homepage&#x60; - Homepage (descending) * &#x60;built_using&#x60; - Built using * &#x60;-built_using&#x60; - Built using (descending) * &#x60;auto_built_package&#x60; - Auto built package * &#x60;-auto_built_package&#x60; - Auto built package (descending) * &#x60;multi_arch&#x60; - Multi arch * &#x60;-multi_arch&#x60; - Multi arch (descending) * &#x60;breaks&#x60; - Breaks * &#x60;-breaks&#x60; - Breaks (descending) * &#x60;conflicts&#x60; - Conflicts * &#x60;-conflicts&#x60; - Conflicts (descending) * &#x60;depends&#x60; - Depends * &#x60;-depends&#x60; - Depends (descending) * &#x60;recommends&#x60; - Recommends * &#x60;-recommends&#x60; - Recommends (descending) * &#x60;suggests&#x60; - Suggests * &#x60;-suggests&#x60; - Suggests (descending) * &#x60;enhances&#x60; - Enhances * &#x60;-enhances&#x60; - Enhances (descending) * &#x60;pre_depends&#x60; - Pre depends * &#x60;-pre_depends&#x60; - Pre depends (descending) * &#x60;provides&#x60; - Provides * &#x60;-provides&#x60; - Provides (descending) * &#x60;replaces&#x60; - Replaces * &#x60;-replaces&#x60; - Replaces (descending) * &#x60;relative_path&#x60; - Relative path * &#x60;-relative_path&#x60; - Relative path (descending) * &#x60;sha256&#x60; - Sha256 * &#x60;-sha256&#x60; - Sha256 (descending) * &#x60;custom_fields&#x60; - Custom fields * &#x60;-custom_fields&#x60; - Custom fields (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [String] :origin Filter results where origin matches value
    # @option opts [String] :original_maintainer Filter results where original_maintainer matches value
    # @option opts [Float] :orphaned_for Minutes Content has been orphaned for. -1 uses ORPHAN_PROTECTION_TIME.
    # @option opts [String] :package Filter results where package matches value
    # @option opts [String] :package__contains Filter results where package contains value
    # @option opts [String] :package__icontains Filter results where package contains value
    # @option opts [String] :package__iexact Filter results where package matches value
    # @option opts [Array<String>] :package__in Filter results where package is in a comma-separated list of values
    # @option opts [String] :package__iregex Filter results where package matches regex value
    # @option opts [String] :package__istartswith Filter results where package starts with value
    # @option opts [String] :package__regex Filter results where package matches regex value
    # @option opts [String] :package__startswith Filter results where package starts with value
    # @option opts [String] :priority Filter results where priority matches value
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q 
    # @option opts [String] :relative_path Filter results where relative_path matches value
    # @option opts [String] :release      Must be a comma-separated string: \&quot;release_href,repository_or_repository_version_href\&quot;     release_href: Filter results where Package in Release     repository_or_repository_version_href: The RepositoryVersion href to filter by, or Repository         href (assume latest version)     
    # @option opts [String] :release_component      Must be a comma-separated string: \&quot;release_component_href,repository_or_repository_version_href\&quot;     release_component_href: Filter results where Package in ReleaseComponent     repository_or_repository_version_href: The RepositoryVersion href to filter by, or Repository         href (assume latest version)     
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :section Filter results where section matches value
    # @option opts [String] :sha256 Filter results where sha256 matches value
    # @option opts [String] :source Filter results where source matches value
    # @option opts [String] :tag Filter results where tag matches value
    # @option opts [String] :version Filter results where version matches value
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginateddebPackageResponseList, Integer, Hash)>] PaginateddebPackageResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagesApi.list ...'
      end
      allowable_values = ["false", "true"]
      if @api_client.config.client_side_validation && opts[:'build_essential'] && !allowable_values.include?(opts[:'build_essential'])
        fail ArgumentError, "invalid value for \"build_essential\", must be one of #{allowable_values}"
      end
      allowable_values = ["false", "true"]
      if @api_client.config.client_side_validation && opts[:'essential'] && !allowable_values.include?(opts[:'essential'])
        fail ArgumentError, "invalid value for \"essential\", must be one of #{allowable_values}"
      end
      allowable_values = ["allowed", "foreign", "no", "same"]
      if @api_client.config.client_side_validation && opts[:'multi_arch'] && !allowable_values.include?(opts[:'multi_arch'])
        fail ArgumentError, "invalid value for \"multi_arch\", must be one of #{allowable_values}"
      end
      allowable_values = ["-architecture", "-auto_built_package", "-breaks", "-bugs", "-build_essential", "-built_using", "-conflicts", "-custom_fields", "-depends", "-description", "-description_md5", "-enhances", "-essential", "-homepage", "-installed_size", "-maintainer", "-multi_arch", "-origin", "-original_maintainer", "-package", "-pk", "-pre_depends", "-priority", "-provides", "-pulp_created", "-pulp_id", "-pulp_last_updated", "-pulp_type", "-recommends", "-relative_path", "-replaces", "-section", "-sha256", "-source", "-suggests", "-tag", "-timestamp_of_interest", "-upstream_id", "-version", "architecture", "auto_built_package", "breaks", "bugs", "build_essential", "built_using", "conflicts", "custom_fields", "depends", "description", "description_md5", "enhances", "essential", "homepage", "installed_size", "maintainer", "multi_arch", "origin", "original_maintainer", "package", "pk", "pre_depends", "priority", "provides", "pulp_created", "pulp_id", "pulp_last_updated", "pulp_type", "recommends", "relative_path", "replaces", "section", "sha256", "source", "suggests", "tag", "timestamp_of_interest", "upstream_id", "version"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/packages/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'architecture'] = opts[:'architecture'] if !opts[:'architecture'].nil?
      query_params[:'auto_built_package'] = opts[:'auto_built_package'] if !opts[:'auto_built_package'].nil?
      query_params[:'build_essential'] = opts[:'build_essential'] if !opts[:'build_essential'].nil?
      query_params[:'built_using'] = opts[:'built_using'] if !opts[:'built_using'].nil?
      query_params[:'essential'] = opts[:'essential'] if !opts[:'essential'].nil?
      query_params[:'installed_size'] = opts[:'installed_size'] if !opts[:'installed_size'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'maintainer'] = opts[:'maintainer'] if !opts[:'maintainer'].nil?
      query_params[:'multi_arch'] = opts[:'multi_arch'] if !opts[:'multi_arch'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'origin'] = opts[:'origin'] if !opts[:'origin'].nil?
      query_params[:'original_maintainer'] = opts[:'original_maintainer'] if !opts[:'original_maintainer'].nil?
      query_params[:'orphaned_for'] = opts[:'orphaned_for'] if !opts[:'orphaned_for'].nil?
      query_params[:'package'] = opts[:'package'] if !opts[:'package'].nil?
      query_params[:'package__contains'] = opts[:'package__contains'] if !opts[:'package__contains'].nil?
      query_params[:'package__icontains'] = opts[:'package__icontains'] if !opts[:'package__icontains'].nil?
      query_params[:'package__iexact'] = opts[:'package__iexact'] if !opts[:'package__iexact'].nil?
      query_params[:'package__in'] = @api_client.build_collection_param(opts[:'package__in'], :csv) if !opts[:'package__in'].nil?
      query_params[:'package__iregex'] = opts[:'package__iregex'] if !opts[:'package__iregex'].nil?
      query_params[:'package__istartswith'] = opts[:'package__istartswith'] if !opts[:'package__istartswith'].nil?
      query_params[:'package__regex'] = opts[:'package__regex'] if !opts[:'package__regex'].nil?
      query_params[:'package__startswith'] = opts[:'package__startswith'] if !opts[:'package__startswith'].nil?
      query_params[:'priority'] = opts[:'priority'] if !opts[:'priority'].nil?
      query_params[:'pulp_href__in'] = @api_client.build_collection_param(opts[:'pulp_href__in'], :csv) if !opts[:'pulp_href__in'].nil?
      query_params[:'pulp_id__in'] = @api_client.build_collection_param(opts[:'pulp_id__in'], :csv) if !opts[:'pulp_id__in'].nil?
      query_params[:'q'] = opts[:'q'] if !opts[:'q'].nil?
      query_params[:'relative_path'] = opts[:'relative_path'] if !opts[:'relative_path'].nil?
      query_params[:'release'] = opts[:'release'] if !opts[:'release'].nil?
      query_params[:'release_component'] = opts[:'release_component'] if !opts[:'release_component'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'section'] = opts[:'section'] if !opts[:'section'].nil?
      query_params[:'sha256'] = opts[:'sha256'] if !opts[:'sha256'].nil?
      query_params[:'source'] = opts[:'source'] if !opts[:'source'].nil?
      query_params[:'tag'] = opts[:'tag'] if !opts[:'tag'].nil?
      query_params[:'version'] = opts[:'version'] if !opts[:'version'].nil?
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginateddebPackageResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a package
    # A Package represents a '.deb' binary package.  Associated artifacts: Exactly one '.deb' package file.
    # @param deb_package_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [DebPackageResponse]
    def read(deb_package_href, opts = {})
      data, _status_code, _headers = read_with_http_info(deb_package_href, opts)
      data
    end

    # Inspect a package
    # A Package represents a &#39;.deb&#39; binary package.  Associated artifacts: Exactly one &#39;.deb&#39; package file.
    # @param deb_package_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(DebPackageResponse, Integer, Hash)>] DebPackageResponse data, response status code and response headers
    def read_with_http_info(deb_package_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagesApi.read ...'
      end
      # verify the required parameter 'deb_package_href' is set
      if @api_client.config.client_side_validation && deb_package_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_package_href' when calling ContentPackagesApi.read"
      end
      # resource path
      local_var_path = '{deb_package_href}'.sub('{' + 'deb_package_href' + '}', CGI.escape(deb_package_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DebPackageResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
