=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpDebClient
  class ContentReleasesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a release
    # The Release contains release file fields, that are not relevant to the APT repo structure.  Associated artifacts: None; contains only metadata.  By non-structure relevant release file fields, we mean anything other than the Components and Architectures fields. These are handled by their own models and are not part of this model.  Note that the distribution field is part of this model, but is not added to any published release files. The \"distribution\" is defined as the path between 'dists/' and some 'Release' file. As such, it encodes the path to the relevant release file within the APT repository. It is often (but not always) equal to the \"codename\" or the \"suite\".
    # @param deb_release [DebRelease] 
    # @param [Hash] opts the optional parameters
    # @return [DebReleaseResponse]
    def create(deb_release, opts = {})
      data, _status_code, _headers = create_with_http_info(deb_release, opts)
      data
    end

    # Create a release
    # The Release contains release file fields, that are not relevant to the APT repo structure.  Associated artifacts: None; contains only metadata.  By non-structure relevant release file fields, we mean anything other than the Components and Architectures fields. These are handled by their own models and are not part of this model.  Note that the distribution field is part of this model, but is not added to any published release files. The \&quot;distribution\&quot; is defined as the path between &#39;dists/&#39; and some &#39;Release&#39; file. As such, it encodes the path to the relevant release file within the APT repository. It is often (but not always) equal to the \&quot;codename\&quot; or the \&quot;suite\&quot;.
    # @param deb_release [DebRelease] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(DebReleaseResponse, Integer, Hash)>] DebReleaseResponse data, response status code and response headers
    def create_with_http_info(deb_release, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentReleasesApi.create ...'
      end
      # verify the required parameter 'deb_release' is set
      if @api_client.config.client_side_validation && deb_release.nil?
        fail ArgumentError, "Missing the required parameter 'deb_release' when calling ContentReleasesApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/releases/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(deb_release) 

      # return_type
      return_type = opts[:return_type] || 'DebReleaseResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentReleasesApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List releases
    # The Release contains release file fields, that are not relevant to the APT repo structure.  Associated artifacts: None; contains only metadata.  By non-structure relevant release file fields, we mean anything other than the Components and Architectures fields. These are handled by their own models and are not part of this model.  Note that the distribution field is part of this model, but is not added to any published release files. The \"distribution\" is defined as the path between 'dists/' and some 'Release' file. As such, it encodes the path to the relevant release file within the APT repository. It is often (but not always) equal to the \"codename\" or the \"suite\".
    # @param [Hash] opts the optional parameters
    # @option opts [String] :codename Filter results where codename matches value
    # @option opts [String] :distribution Filter results where distribution matches value
    # @option opts [String] :label Filter results where label matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;upstream_id&#x60; - Upstream id * &#x60;-upstream_id&#x60; - Upstream id (descending) * &#x60;timestamp_of_interest&#x60; - Timestamp of interest * &#x60;-timestamp_of_interest&#x60; - Timestamp of interest (descending) * &#x60;codename&#x60; - Codename * &#x60;-codename&#x60; - Codename (descending) * &#x60;suite&#x60; - Suite * &#x60;-suite&#x60; - Suite (descending) * &#x60;distribution&#x60; - Distribution * &#x60;-distribution&#x60; - Distribution (descending) * &#x60;version&#x60; - Version * &#x60;-version&#x60; - Version (descending) * &#x60;origin&#x60; - Origin * &#x60;-origin&#x60; - Origin (descending) * &#x60;label&#x60; - Label * &#x60;-label&#x60; - Label (descending) * &#x60;description&#x60; - Description * &#x60;-description&#x60; - Description (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [String] :origin Filter results where origin matches value
    # @option opts [Float] :orphaned_for Minutes Content has been orphaned for. -1 uses ORPHAN_PROTECTION_TIME.
    # @option opts [String] :package      Must be a comma-separated string: \&quot;package_href,repository_or_repository_version_href\&quot;     package_href: Filter results where Release contains Package     repository_or_repository_version_href: The RepositoryVersion href to filter by, or Repository         href (assume latest version)     
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q 
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :suite Filter results where suite matches value
    # @option opts [String] :version Filter results where version matches value
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginateddebReleaseResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List releases
    # The Release contains release file fields, that are not relevant to the APT repo structure.  Associated artifacts: None; contains only metadata.  By non-structure relevant release file fields, we mean anything other than the Components and Architectures fields. These are handled by their own models and are not part of this model.  Note that the distribution field is part of this model, but is not added to any published release files. The \&quot;distribution\&quot; is defined as the path between &#39;dists/&#39; and some &#39;Release&#39; file. As such, it encodes the path to the relevant release file within the APT repository. It is often (but not always) equal to the \&quot;codename\&quot; or the \&quot;suite\&quot;.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :codename Filter results where codename matches value
    # @option opts [String] :distribution Filter results where distribution matches value
    # @option opts [String] :label Filter results where label matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;upstream_id&#x60; - Upstream id * &#x60;-upstream_id&#x60; - Upstream id (descending) * &#x60;timestamp_of_interest&#x60; - Timestamp of interest * &#x60;-timestamp_of_interest&#x60; - Timestamp of interest (descending) * &#x60;codename&#x60; - Codename * &#x60;-codename&#x60; - Codename (descending) * &#x60;suite&#x60; - Suite * &#x60;-suite&#x60; - Suite (descending) * &#x60;distribution&#x60; - Distribution * &#x60;-distribution&#x60; - Distribution (descending) * &#x60;version&#x60; - Version * &#x60;-version&#x60; - Version (descending) * &#x60;origin&#x60; - Origin * &#x60;-origin&#x60; - Origin (descending) * &#x60;label&#x60; - Label * &#x60;-label&#x60; - Label (descending) * &#x60;description&#x60; - Description * &#x60;-description&#x60; - Description (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [String] :origin Filter results where origin matches value
    # @option opts [Float] :orphaned_for Minutes Content has been orphaned for. -1 uses ORPHAN_PROTECTION_TIME.
    # @option opts [String] :package      Must be a comma-separated string: \&quot;package_href,repository_or_repository_version_href\&quot;     package_href: Filter results where Release contains Package     repository_or_repository_version_href: The RepositoryVersion href to filter by, or Repository         href (assume latest version)     
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q 
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :suite Filter results where suite matches value
    # @option opts [String] :version Filter results where version matches value
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginateddebReleaseResponseList, Integer, Hash)>] PaginateddebReleaseResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentReleasesApi.list ...'
      end
      allowable_values = ["-codename", "-description", "-distribution", "-label", "-origin", "-pk", "-pulp_created", "-pulp_id", "-pulp_last_updated", "-pulp_type", "-suite", "-timestamp_of_interest", "-upstream_id", "-version", "codename", "description", "distribution", "label", "origin", "pk", "pulp_created", "pulp_id", "pulp_last_updated", "pulp_type", "suite", "timestamp_of_interest", "upstream_id", "version"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/releases/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'codename'] = opts[:'codename'] if !opts[:'codename'].nil?
      query_params[:'distribution'] = opts[:'distribution'] if !opts[:'distribution'].nil?
      query_params[:'label'] = opts[:'label'] if !opts[:'label'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'origin'] = opts[:'origin'] if !opts[:'origin'].nil?
      query_params[:'orphaned_for'] = opts[:'orphaned_for'] if !opts[:'orphaned_for'].nil?
      query_params[:'package'] = opts[:'package'] if !opts[:'package'].nil?
      query_params[:'pulp_href__in'] = @api_client.build_collection_param(opts[:'pulp_href__in'], :csv) if !opts[:'pulp_href__in'].nil?
      query_params[:'pulp_id__in'] = @api_client.build_collection_param(opts[:'pulp_id__in'], :csv) if !opts[:'pulp_id__in'].nil?
      query_params[:'q'] = opts[:'q'] if !opts[:'q'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'suite'] = opts[:'suite'] if !opts[:'suite'].nil?
      query_params[:'version'] = opts[:'version'] if !opts[:'version'].nil?
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginateddebReleaseResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentReleasesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a release
    # The Release contains release file fields, that are not relevant to the APT repo structure.  Associated artifacts: None; contains only metadata.  By non-structure relevant release file fields, we mean anything other than the Components and Architectures fields. These are handled by their own models and are not part of this model.  Note that the distribution field is part of this model, but is not added to any published release files. The \"distribution\" is defined as the path between 'dists/' and some 'Release' file. As such, it encodes the path to the relevant release file within the APT repository. It is often (but not always) equal to the \"codename\" or the \"suite\".
    # @param deb_release_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [DebReleaseResponse]
    def read(deb_release_href, opts = {})
      data, _status_code, _headers = read_with_http_info(deb_release_href, opts)
      data
    end

    # Inspect a release
    # The Release contains release file fields, that are not relevant to the APT repo structure.  Associated artifacts: None; contains only metadata.  By non-structure relevant release file fields, we mean anything other than the Components and Architectures fields. These are handled by their own models and are not part of this model.  Note that the distribution field is part of this model, but is not added to any published release files. The \&quot;distribution\&quot; is defined as the path between &#39;dists/&#39; and some &#39;Release&#39; file. As such, it encodes the path to the relevant release file within the APT repository. It is often (but not always) equal to the \&quot;codename\&quot; or the \&quot;suite\&quot;.
    # @param deb_release_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(DebReleaseResponse, Integer, Hash)>] DebReleaseResponse data, response status code and response headers
    def read_with_http_info(deb_release_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentReleasesApi.read ...'
      end
      # verify the required parameter 'deb_release_href' is set
      if @api_client.config.client_side_validation && deb_release_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_release_href' when calling ContentReleasesApi.read"
      end
      # resource path
      local_var_path = '{deb_release_href}'.sub('{' + 'deb_release_href' + '}', CGI.escape(deb_release_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DebReleaseResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentReleasesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
