=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpDebClient
  class ContentSourcePackagesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a source package
    # Trigger an asynchronous task to create content,optionally create new repository version.
    # @param deb_source_package [DebSourcePackage] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def create(deb_source_package, opts = {})
      data, _status_code, _headers = create_with_http_info(deb_source_package, opts)
      data
    end

    # Create a source package
    # Trigger an asynchronous task to create content,optionally create new repository version.
    # @param deb_source_package [DebSourcePackage] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def create_with_http_info(deb_source_package, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentSourcePackagesApi.create ...'
      end
      # verify the required parameter 'deb_source_package' is set
      if @api_client.config.client_side_validation && deb_source_package.nil?
        fail ArgumentError, "Missing the required parameter 'deb_source_package' when calling ContentSourcePackagesApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/source_packages/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(deb_source_package) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentSourcePackagesApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List source packages
    # A Debian Source Package file represents a '.dsc' file along with its associated artifacts such as orig.tar.gz, debian.tar.gz...  Associated artifacts: Exactly one '.dsc' file.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :architecture Filter results where architecture matches value
    # @option opts [String] :binary Filter results where binary matches value
    # @option opts [String] :build_conflicts Filter results where build_conflicts matches value
    # @option opts [String] :build_conflicts_arch Filter results where build_conflicts_arch matches value
    # @option opts [String] :build_conflicts_indep Filter results where build_conflicts_indep matches value
    # @option opts [String] :build_depends Filter results where build_depends matches value
    # @option opts [String] :build_depends_arch Filter results where build_depends_arch matches value
    # @option opts [String] :build_depends_indep Filter results where build_depends_indep matches value
    # @option opts [String] :dgit Filter results where dgit matches value
    # @option opts [String] :format Filter results where format matches value
    # @option opts [String] :homepage Filter results where homepage matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :maintainer Filter results where maintainer matches value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;upstream_id&#x60; - Upstream id * &#x60;-upstream_id&#x60; - Upstream id (descending) * &#x60;timestamp_of_interest&#x60; - Timestamp of interest * &#x60;-timestamp_of_interest&#x60; - Timestamp of interest (descending) * &#x60;relative_path&#x60; - Relative path * &#x60;-relative_path&#x60; - Relative path (descending) * &#x60;format&#x60; - Format * &#x60;-format&#x60; - Format (descending) * &#x60;source&#x60; - Source * &#x60;-source&#x60; - Source (descending) * &#x60;binary&#x60; - Binary * &#x60;-binary&#x60; - Binary (descending) * &#x60;architecture&#x60; - Architecture * &#x60;-architecture&#x60; - Architecture (descending) * &#x60;version&#x60; - Version * &#x60;-version&#x60; - Version (descending) * &#x60;maintainer&#x60; - Maintainer * &#x60;-maintainer&#x60; - Maintainer (descending) * &#x60;uploaders&#x60; - Uploaders * &#x60;-uploaders&#x60; - Uploaders (descending) * &#x60;homepage&#x60; - Homepage * &#x60;-homepage&#x60; - Homepage (descending) * &#x60;vcs_browser&#x60; - Vcs browser * &#x60;-vcs_browser&#x60; - Vcs browser (descending) * &#x60;vcs_arch&#x60; - Vcs arch * &#x60;-vcs_arch&#x60; - Vcs arch (descending) * &#x60;vcs_bzr&#x60; - Vcs bzr * &#x60;-vcs_bzr&#x60; - Vcs bzr (descending) * &#x60;vcs_cvs&#x60; - Vcs cvs * &#x60;-vcs_cvs&#x60; - Vcs cvs (descending) * &#x60;vcs_darcs&#x60; - Vcs darcs * &#x60;-vcs_darcs&#x60; - Vcs darcs (descending) * &#x60;vcs_git&#x60; - Vcs git * &#x60;-vcs_git&#x60; - Vcs git (descending) * &#x60;vcs_hg&#x60; - Vcs hg * &#x60;-vcs_hg&#x60; - Vcs hg (descending) * &#x60;vcs_mtn&#x60; - Vcs mtn * &#x60;-vcs_mtn&#x60; - Vcs mtn (descending) * &#x60;vcs_snv&#x60; - Vcs snv * &#x60;-vcs_snv&#x60; - Vcs snv (descending) * &#x60;testsuite&#x60; - Testsuite * &#x60;-testsuite&#x60; - Testsuite (descending) * &#x60;dgit&#x60; - Dgit * &#x60;-dgit&#x60; - Dgit (descending) * &#x60;standards_version&#x60; - Standards version * &#x60;-standards_version&#x60; - Standards version (descending) * &#x60;build_depends&#x60; - Build depends * &#x60;-build_depends&#x60; - Build depends (descending) * &#x60;build_depends_indep&#x60; - Build depends indep * &#x60;-build_depends_indep&#x60; - Build depends indep (descending) * &#x60;build_depends_arch&#x60; - Build depends arch * &#x60;-build_depends_arch&#x60; - Build depends arch (descending) * &#x60;build_conflicts&#x60; - Build conflicts * &#x60;-build_conflicts&#x60; - Build conflicts (descending) * &#x60;build_conflicts_indep&#x60; - Build conflicts indep * &#x60;-build_conflicts_indep&#x60; - Build conflicts indep (descending) * &#x60;build_conflicts_arch&#x60; - Build conflicts arch * &#x60;-build_conflicts_arch&#x60; - Build conflicts arch (descending) * &#x60;package_list&#x60; - Package list * &#x60;-package_list&#x60; - Package list (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Float] :orphaned_for Minutes Content has been orphaned for. -1 uses ORPHAN_PROTECTION_TIME.
    # @option opts [String] :package_list Filter results where package_list matches value
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q 
    # @option opts [String] :relative_path Filter results where relative_path matches value
    # @option opts [String] :release      Must be a comma-separated string: \&quot;release_href,repository_or_repository_version_href\&quot;     release_href: Filter results where SourcePackage in Release     repository_or_repository_version_href: The RepositoryVersion href to filter by, or Repository         href (assume latest version)     
    # @option opts [String] :release_component      Must be a comma-separated string: \&quot;release_component_href,repository_or_repository_version_href\&quot;     release_component_href: Filter results where SourcePackage in ReleaseComponent     repository_or_repository_version_href: The RepositoryVersion href to filter by, or Repository         href (assume latest version)     
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :source Filter results where source matches value
    # @option opts [String] :standards_version Filter results where standards_version matches value
    # @option opts [String] :testsuite Filter results where testsuite matches value
    # @option opts [String] :uploaders Filter results where uploaders matches value
    # @option opts [String] :vcs_arch Filter results where vcs_arch matches value
    # @option opts [String] :vcs_browser Filter results where vcs_browser matches value
    # @option opts [String] :vcs_bzr Filter results where vcs_bzr matches value
    # @option opts [String] :vcs_cvs Filter results where vcs_cvs matches value
    # @option opts [String] :vcs_darcs Filter results where vcs_darcs matches value
    # @option opts [String] :vcs_git Filter results where vcs_git matches value
    # @option opts [String] :vcs_hg Filter results where vcs_hg matches value
    # @option opts [String] :vcs_mtn Filter results where vcs_mtn matches value
    # @option opts [String] :vcs_snv Filter results where vcs_snv matches value
    # @option opts [String] :version Filter results where version matches value
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginateddebSourcePackageResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List source packages
    # A Debian Source Package file represents a &#39;.dsc&#39; file along with its associated artifacts such as orig.tar.gz, debian.tar.gz...  Associated artifacts: Exactly one &#39;.dsc&#39; file.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :architecture Filter results where architecture matches value
    # @option opts [String] :binary Filter results where binary matches value
    # @option opts [String] :build_conflicts Filter results where build_conflicts matches value
    # @option opts [String] :build_conflicts_arch Filter results where build_conflicts_arch matches value
    # @option opts [String] :build_conflicts_indep Filter results where build_conflicts_indep matches value
    # @option opts [String] :build_depends Filter results where build_depends matches value
    # @option opts [String] :build_depends_arch Filter results where build_depends_arch matches value
    # @option opts [String] :build_depends_indep Filter results where build_depends_indep matches value
    # @option opts [String] :dgit Filter results where dgit matches value
    # @option opts [String] :format Filter results where format matches value
    # @option opts [String] :homepage Filter results where homepage matches value
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :maintainer Filter results where maintainer matches value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;upstream_id&#x60; - Upstream id * &#x60;-upstream_id&#x60; - Upstream id (descending) * &#x60;timestamp_of_interest&#x60; - Timestamp of interest * &#x60;-timestamp_of_interest&#x60; - Timestamp of interest (descending) * &#x60;relative_path&#x60; - Relative path * &#x60;-relative_path&#x60; - Relative path (descending) * &#x60;format&#x60; - Format * &#x60;-format&#x60; - Format (descending) * &#x60;source&#x60; - Source * &#x60;-source&#x60; - Source (descending) * &#x60;binary&#x60; - Binary * &#x60;-binary&#x60; - Binary (descending) * &#x60;architecture&#x60; - Architecture * &#x60;-architecture&#x60; - Architecture (descending) * &#x60;version&#x60; - Version * &#x60;-version&#x60; - Version (descending) * &#x60;maintainer&#x60; - Maintainer * &#x60;-maintainer&#x60; - Maintainer (descending) * &#x60;uploaders&#x60; - Uploaders * &#x60;-uploaders&#x60; - Uploaders (descending) * &#x60;homepage&#x60; - Homepage * &#x60;-homepage&#x60; - Homepage (descending) * &#x60;vcs_browser&#x60; - Vcs browser * &#x60;-vcs_browser&#x60; - Vcs browser (descending) * &#x60;vcs_arch&#x60; - Vcs arch * &#x60;-vcs_arch&#x60; - Vcs arch (descending) * &#x60;vcs_bzr&#x60; - Vcs bzr * &#x60;-vcs_bzr&#x60; - Vcs bzr (descending) * &#x60;vcs_cvs&#x60; - Vcs cvs * &#x60;-vcs_cvs&#x60; - Vcs cvs (descending) * &#x60;vcs_darcs&#x60; - Vcs darcs * &#x60;-vcs_darcs&#x60; - Vcs darcs (descending) * &#x60;vcs_git&#x60; - Vcs git * &#x60;-vcs_git&#x60; - Vcs git (descending) * &#x60;vcs_hg&#x60; - Vcs hg * &#x60;-vcs_hg&#x60; - Vcs hg (descending) * &#x60;vcs_mtn&#x60; - Vcs mtn * &#x60;-vcs_mtn&#x60; - Vcs mtn (descending) * &#x60;vcs_snv&#x60; - Vcs snv * &#x60;-vcs_snv&#x60; - Vcs snv (descending) * &#x60;testsuite&#x60; - Testsuite * &#x60;-testsuite&#x60; - Testsuite (descending) * &#x60;dgit&#x60; - Dgit * &#x60;-dgit&#x60; - Dgit (descending) * &#x60;standards_version&#x60; - Standards version * &#x60;-standards_version&#x60; - Standards version (descending) * &#x60;build_depends&#x60; - Build depends * &#x60;-build_depends&#x60; - Build depends (descending) * &#x60;build_depends_indep&#x60; - Build depends indep * &#x60;-build_depends_indep&#x60; - Build depends indep (descending) * &#x60;build_depends_arch&#x60; - Build depends arch * &#x60;-build_depends_arch&#x60; - Build depends arch (descending) * &#x60;build_conflicts&#x60; - Build conflicts * &#x60;-build_conflicts&#x60; - Build conflicts (descending) * &#x60;build_conflicts_indep&#x60; - Build conflicts indep * &#x60;-build_conflicts_indep&#x60; - Build conflicts indep (descending) * &#x60;build_conflicts_arch&#x60; - Build conflicts arch * &#x60;-build_conflicts_arch&#x60; - Build conflicts arch (descending) * &#x60;package_list&#x60; - Package list * &#x60;-package_list&#x60; - Package list (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Float] :orphaned_for Minutes Content has been orphaned for. -1 uses ORPHAN_PROTECTION_TIME.
    # @option opts [String] :package_list Filter results where package_list matches value
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q 
    # @option opts [String] :relative_path Filter results where relative_path matches value
    # @option opts [String] :release      Must be a comma-separated string: \&quot;release_href,repository_or_repository_version_href\&quot;     release_href: Filter results where SourcePackage in Release     repository_or_repository_version_href: The RepositoryVersion href to filter by, or Repository         href (assume latest version)     
    # @option opts [String] :release_component      Must be a comma-separated string: \&quot;release_component_href,repository_or_repository_version_href\&quot;     release_component_href: Filter results where SourcePackage in ReleaseComponent     repository_or_repository_version_href: The RepositoryVersion href to filter by, or Repository         href (assume latest version)     
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :source Filter results where source matches value
    # @option opts [String] :standards_version Filter results where standards_version matches value
    # @option opts [String] :testsuite Filter results where testsuite matches value
    # @option opts [String] :uploaders Filter results where uploaders matches value
    # @option opts [String] :vcs_arch Filter results where vcs_arch matches value
    # @option opts [String] :vcs_browser Filter results where vcs_browser matches value
    # @option opts [String] :vcs_bzr Filter results where vcs_bzr matches value
    # @option opts [String] :vcs_cvs Filter results where vcs_cvs matches value
    # @option opts [String] :vcs_darcs Filter results where vcs_darcs matches value
    # @option opts [String] :vcs_git Filter results where vcs_git matches value
    # @option opts [String] :vcs_hg Filter results where vcs_hg matches value
    # @option opts [String] :vcs_mtn Filter results where vcs_mtn matches value
    # @option opts [String] :vcs_snv Filter results where vcs_snv matches value
    # @option opts [String] :version Filter results where version matches value
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginateddebSourcePackageResponseList, Integer, Hash)>] PaginateddebSourcePackageResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentSourcePackagesApi.list ...'
      end
      allowable_values = ["-architecture", "-binary", "-build_conflicts", "-build_conflicts_arch", "-build_conflicts_indep", "-build_depends", "-build_depends_arch", "-build_depends_indep", "-dgit", "-format", "-homepage", "-maintainer", "-package_list", "-pk", "-pulp_created", "-pulp_id", "-pulp_last_updated", "-pulp_type", "-relative_path", "-source", "-standards_version", "-testsuite", "-timestamp_of_interest", "-uploaders", "-upstream_id", "-vcs_arch", "-vcs_browser", "-vcs_bzr", "-vcs_cvs", "-vcs_darcs", "-vcs_git", "-vcs_hg", "-vcs_mtn", "-vcs_snv", "-version", "architecture", "binary", "build_conflicts", "build_conflicts_arch", "build_conflicts_indep", "build_depends", "build_depends_arch", "build_depends_indep", "dgit", "format", "homepage", "maintainer", "package_list", "pk", "pulp_created", "pulp_id", "pulp_last_updated", "pulp_type", "relative_path", "source", "standards_version", "testsuite", "timestamp_of_interest", "uploaders", "upstream_id", "vcs_arch", "vcs_browser", "vcs_bzr", "vcs_cvs", "vcs_darcs", "vcs_git", "vcs_hg", "vcs_mtn", "vcs_snv", "version"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/source_packages/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'architecture'] = opts[:'architecture'] if !opts[:'architecture'].nil?
      query_params[:'binary'] = opts[:'binary'] if !opts[:'binary'].nil?
      query_params[:'build_conflicts'] = opts[:'build_conflicts'] if !opts[:'build_conflicts'].nil?
      query_params[:'build_conflicts_arch'] = opts[:'build_conflicts_arch'] if !opts[:'build_conflicts_arch'].nil?
      query_params[:'build_conflicts_indep'] = opts[:'build_conflicts_indep'] if !opts[:'build_conflicts_indep'].nil?
      query_params[:'build_depends'] = opts[:'build_depends'] if !opts[:'build_depends'].nil?
      query_params[:'build_depends_arch'] = opts[:'build_depends_arch'] if !opts[:'build_depends_arch'].nil?
      query_params[:'build_depends_indep'] = opts[:'build_depends_indep'] if !opts[:'build_depends_indep'].nil?
      query_params[:'dgit'] = opts[:'dgit'] if !opts[:'dgit'].nil?
      query_params[:'format'] = opts[:'format'] if !opts[:'format'].nil?
      query_params[:'homepage'] = opts[:'homepage'] if !opts[:'homepage'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'maintainer'] = opts[:'maintainer'] if !opts[:'maintainer'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'orphaned_for'] = opts[:'orphaned_for'] if !opts[:'orphaned_for'].nil?
      query_params[:'package_list'] = opts[:'package_list'] if !opts[:'package_list'].nil?
      query_params[:'pulp_href__in'] = @api_client.build_collection_param(opts[:'pulp_href__in'], :csv) if !opts[:'pulp_href__in'].nil?
      query_params[:'pulp_id__in'] = @api_client.build_collection_param(opts[:'pulp_id__in'], :csv) if !opts[:'pulp_id__in'].nil?
      query_params[:'q'] = opts[:'q'] if !opts[:'q'].nil?
      query_params[:'relative_path'] = opts[:'relative_path'] if !opts[:'relative_path'].nil?
      query_params[:'release'] = opts[:'release'] if !opts[:'release'].nil?
      query_params[:'release_component'] = opts[:'release_component'] if !opts[:'release_component'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'source'] = opts[:'source'] if !opts[:'source'].nil?
      query_params[:'standards_version'] = opts[:'standards_version'] if !opts[:'standards_version'].nil?
      query_params[:'testsuite'] = opts[:'testsuite'] if !opts[:'testsuite'].nil?
      query_params[:'uploaders'] = opts[:'uploaders'] if !opts[:'uploaders'].nil?
      query_params[:'vcs_arch'] = opts[:'vcs_arch'] if !opts[:'vcs_arch'].nil?
      query_params[:'vcs_browser'] = opts[:'vcs_browser'] if !opts[:'vcs_browser'].nil?
      query_params[:'vcs_bzr'] = opts[:'vcs_bzr'] if !opts[:'vcs_bzr'].nil?
      query_params[:'vcs_cvs'] = opts[:'vcs_cvs'] if !opts[:'vcs_cvs'].nil?
      query_params[:'vcs_darcs'] = opts[:'vcs_darcs'] if !opts[:'vcs_darcs'].nil?
      query_params[:'vcs_git'] = opts[:'vcs_git'] if !opts[:'vcs_git'].nil?
      query_params[:'vcs_hg'] = opts[:'vcs_hg'] if !opts[:'vcs_hg'].nil?
      query_params[:'vcs_mtn'] = opts[:'vcs_mtn'] if !opts[:'vcs_mtn'].nil?
      query_params[:'vcs_snv'] = opts[:'vcs_snv'] if !opts[:'vcs_snv'].nil?
      query_params[:'version'] = opts[:'version'] if !opts[:'version'].nil?
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginateddebSourcePackageResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentSourcePackagesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a source package
    # A Debian Source Package file represents a '.dsc' file along with its associated artifacts such as orig.tar.gz, debian.tar.gz...  Associated artifacts: Exactly one '.dsc' file.
    # @param deb_source_package_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [DebSourcePackageResponse]
    def read(deb_source_package_href, opts = {})
      data, _status_code, _headers = read_with_http_info(deb_source_package_href, opts)
      data
    end

    # Inspect a source package
    # A Debian Source Package file represents a &#39;.dsc&#39; file along with its associated artifacts such as orig.tar.gz, debian.tar.gz...  Associated artifacts: Exactly one &#39;.dsc&#39; file.
    # @param deb_source_package_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(DebSourcePackageResponse, Integer, Hash)>] DebSourcePackageResponse data, response status code and response headers
    def read_with_http_info(deb_source_package_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentSourcePackagesApi.read ...'
      end
      # verify the required parameter 'deb_source_package_href' is set
      if @api_client.config.client_side_validation && deb_source_package_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_source_package_href' when calling ContentSourcePackagesApi.read"
      end
      # resource path
      local_var_path = '{deb_source_package_href}'.sub('{' + 'deb_source_package_href' + '}', CGI.escape(deb_source_package_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DebSourcePackageResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentSourcePackagesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
