=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpDebClient
  class ContentSourceReleaseComponentsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a source package release component
    # A SourcePackageReleaseComponent associates a SourcePackage with a ReleaseComponent.  Associated artifacts: None; contains only metadata.  This simply stores the information on which source packages are part of which components.
    # @param deb_source_package_release_component [DebSourcePackageReleaseComponent] 
    # @param [Hash] opts the optional parameters
    # @return [DebSourcePackageReleaseComponentResponse]
    def create(deb_source_package_release_component, opts = {})
      data, _status_code, _headers = create_with_http_info(deb_source_package_release_component, opts)
      data
    end

    # Create a source package release component
    # A SourcePackageReleaseComponent associates a SourcePackage with a ReleaseComponent.  Associated artifacts: None; contains only metadata.  This simply stores the information on which source packages are part of which components.
    # @param deb_source_package_release_component [DebSourcePackageReleaseComponent] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(DebSourcePackageReleaseComponentResponse, Integer, Hash)>] DebSourcePackageReleaseComponentResponse data, response status code and response headers
    def create_with_http_info(deb_source_package_release_component, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentSourceReleaseComponentsApi.create ...'
      end
      # verify the required parameter 'deb_source_package_release_component' is set
      if @api_client.config.client_side_validation && deb_source_package_release_component.nil?
        fail ArgumentError, "Missing the required parameter 'deb_source_package_release_component' when calling ContentSourceReleaseComponentsApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/source_release_components/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(deb_source_package_release_component) 

      # return_type
      return_type = opts[:return_type] || 'DebSourcePackageReleaseComponentResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentSourceReleaseComponentsApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List source package release components
    # A SourcePackageReleaseComponent associates a SourcePackage with a ReleaseComponent.  Associated artifacts: None; contains only metadata.  This simply stores the information on which source packages are part of which components.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;upstream_id&#x60; - Upstream id * &#x60;-upstream_id&#x60; - Upstream id (descending) * &#x60;timestamp_of_interest&#x60; - Timestamp of interest * &#x60;-timestamp_of_interest&#x60; - Timestamp of interest (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Float] :orphaned_for Minutes Content has been orphaned for. -1 uses ORPHAN_PROTECTION_TIME.
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q 
    # @option opts [String] :release_component Filter results where release_component matches value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :source_package Filter results where source_package matches value
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginateddebSourcePackageReleaseComponentResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List source package release components
    # A SourcePackageReleaseComponent associates a SourcePackage with a ReleaseComponent.  Associated artifacts: None; contains only metadata.  This simply stores the information on which source packages are part of which components.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [Array<String>] :ordering Ordering  * &#x60;pulp_id&#x60; - Pulp id * &#x60;-pulp_id&#x60; - Pulp id (descending) * &#x60;pulp_created&#x60; - Pulp created * &#x60;-pulp_created&#x60; - Pulp created (descending) * &#x60;pulp_last_updated&#x60; - Pulp last updated * &#x60;-pulp_last_updated&#x60; - Pulp last updated (descending) * &#x60;pulp_type&#x60; - Pulp type * &#x60;-pulp_type&#x60; - Pulp type (descending) * &#x60;upstream_id&#x60; - Upstream id * &#x60;-upstream_id&#x60; - Upstream id (descending) * &#x60;timestamp_of_interest&#x60; - Timestamp of interest * &#x60;-timestamp_of_interest&#x60; - Timestamp of interest (descending) * &#x60;pk&#x60; - Pk * &#x60;-pk&#x60; - Pk (descending)
    # @option opts [Float] :orphaned_for Minutes Content has been orphaned for. -1 uses ORPHAN_PROTECTION_TIME.
    # @option opts [Array<String>] :pulp_href__in Multiple values may be separated by commas.
    # @option opts [Array<String>] :pulp_id__in Multiple values may be separated by commas.
    # @option opts [String] :q 
    # @option opts [String] :release_component Filter results where release_component matches value
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :source_package Filter results where source_package matches value
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginateddebSourcePackageReleaseComponentResponseList, Integer, Hash)>] PaginateddebSourcePackageReleaseComponentResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentSourceReleaseComponentsApi.list ...'
      end
      allowable_values = ["-pk", "-pulp_created", "-pulp_id", "-pulp_last_updated", "-pulp_type", "-timestamp_of_interest", "-upstream_id", "pk", "pulp_created", "pulp_id", "pulp_last_updated", "pulp_type", "timestamp_of_interest", "upstream_id"]
      if @api_client.config.client_side_validation && opts[:'ordering'] && !opts[:'ordering'].all? { |item| allowable_values.include?(item) }
        fail ArgumentError, "invalid value for \"ordering\", must include one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/deb/source_release_components/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = @api_client.build_collection_param(opts[:'ordering'], :csv) if !opts[:'ordering'].nil?
      query_params[:'orphaned_for'] = opts[:'orphaned_for'] if !opts[:'orphaned_for'].nil?
      query_params[:'pulp_href__in'] = @api_client.build_collection_param(opts[:'pulp_href__in'], :csv) if !opts[:'pulp_href__in'].nil?
      query_params[:'pulp_id__in'] = @api_client.build_collection_param(opts[:'pulp_id__in'], :csv) if !opts[:'pulp_id__in'].nil?
      query_params[:'q'] = opts[:'q'] if !opts[:'q'].nil?
      query_params[:'release_component'] = opts[:'release_component'] if !opts[:'release_component'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'source_package'] = opts[:'source_package'] if !opts[:'source_package'].nil?
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginateddebSourcePackageReleaseComponentResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentSourceReleaseComponentsApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a source package release component
    # A SourcePackageReleaseComponent associates a SourcePackage with a ReleaseComponent.  Associated artifacts: None; contains only metadata.  This simply stores the information on which source packages are part of which components.
    # @param deb_source_package_release_component_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [DebSourcePackageReleaseComponentResponse]
    def read(deb_source_package_release_component_href, opts = {})
      data, _status_code, _headers = read_with_http_info(deb_source_package_release_component_href, opts)
      data
    end

    # Inspect a source package release component
    # A SourcePackageReleaseComponent associates a SourcePackage with a ReleaseComponent.  Associated artifacts: None; contains only metadata.  This simply stores the information on which source packages are part of which components.
    # @param deb_source_package_release_component_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :fields A list of fields to include in the response.
    # @option opts [Array<String>] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(DebSourcePackageReleaseComponentResponse, Integer, Hash)>] DebSourcePackageReleaseComponentResponse data, response status code and response headers
    def read_with_http_info(deb_source_package_release_component_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentSourceReleaseComponentsApi.read ...'
      end
      # verify the required parameter 'deb_source_package_release_component_href' is set
      if @api_client.config.client_side_validation && deb_source_package_release_component_href.nil?
        fail ArgumentError, "Missing the required parameter 'deb_source_package_release_component_href' when calling ContentSourceReleaseComponentsApi.read"
      end
      # resource path
      local_var_path = '{deb_source_package_release_component_href}'.sub('{' + 'deb_source_package_release_component_href' + '}', CGI.escape(deb_source_package_release_component_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = @api_client.build_collection_param(opts[:'fields'], :multi) if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = @api_client.build_collection_param(opts[:'exclude_fields'], :multi) if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'DebSourcePackageReleaseComponentResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentSourceReleaseComponentsApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
